/* Copyright 1996, Jan D. Wolter and Steven R. Weiss, All Rights Reserved. */

#include "backtalk.h"

#include <ctype.h>

char *ucname(char *n)
{

    if (isalpha(n[0]) || n[0] == '_' || n[0] == '@')
    {
	static char uc[MAXSYMLEN+4];
	int i= 0, j= 0;

	/* Syntactically illegal symbol names starting an @ are for
	 * internal use - not currently used */
	if (n[0] == '@') {
		if (n[1] == '\0') return "AT";
		strcpy(uc,"INT_");
		i= 1;
		j= 4;
	}

	for ( ; n[i] != '\0'; i++,j++)
	    uc[j]= (islower(n[i]) ? toupper(n[i]) : n[i]);
	uc[j]= '\0';
	return uc;
    }

    switch(n[0])
    {
    case '!': return "NOT";
    case '~': return "BNOT";
    case '?': return "BISEL";
    case '*': return "MUL";
    case '+': return "ADD";
    case '-': return "SUB";
    case '/': return "DIV";
    case '#': return "POUND";
    case '&': return "AMPERSAND";
    case '|': return "BAR";
    case '[': return "LBRACKET";
    case ']': return "RBRACKET";
    case '=': return "EQUALS";
    default: return NULL;
    }
}


main()
{
int i;
char *uc;

    printf("/* DO NOT EDIT THIS FILE\n");
    printf(" * It is generated by mksysdict.c from the sysdict.c file.\n");
    printf(" */\n\n");

    for (i= 0; sysdict[i].label[0] != '\0'; i++)
    {
	if ((uc= ucname(sysdict[i].label)) != NULL)
	    printf("#define %s_%s %d\n",
	           (type(sysdict[i].t) == TK_FUNCTION) ? "FUNC" : "VAR", uc, i);

	if (i > 0 && strcmp(sysdict[i-1].label, sysdict[i].label) > 0)
	{
	    fprintf(stderr, "WARNING - SYSDICT NOT IN ORDER!  "
	        "'%s' PRECEEDS '%s'\n",sysdict[i-1].label, sysdict[i].label);
	    exit(1);
	}
    }
    
    printf("\n#define SYSDICTLEN %d\n",i);

    exit(0);
}
